#
# Cheapo "Binary I/O package"
#

proc PutByte {fid val} {
	if {$val > 0} {
		puts -nonewline $fid [ format "%c" $val ]
	} else {
		# maybe use "echo -n x" or "echo x\\c" instead of shell printf
		exec >@ $fid sh -c "printf x | tr x \\\\000"
	}
}
proc PutBytes {fid args} {
	foreach b $args {
		PutByte $fid $b
	}
}

proc GetByte {fid {to 5}} {
	set ready [Readable $fid [expr $to * 1000]]
	if {[string compare [lindex $ready 0] $fid] != 0} {
		msg "Timed out waiting for GetByte"
		return -1
	}
	set byte [read $fid 1]
	if {[string length $byte] == 1} {
		scan $byte "%c" val
		return $val
	} else {
		if [eof $fid] {return -1} else {return 0}
	}
}

proc IFlush {fid} {
	set bytes 0
	while 1 {
		set ready [Readable $fid 0]
		if {[string compare $ready $fid] != 0} {
			# nothing to read
			break
		}
		incr bytes
		set s [read $fid 1]
	}
	return $bytes
}

proc Readable {fidlist {to _}} {
	global _readable
	if [string match {[0-9]*} $to] {
		if [string match 0 $to] {
			set to idle
		}
		after $to set _readable ""
	}
	set _readable ""
	foreach fid $fidlist {
		fileevent $fid readable [list set _readable $fid]
	}
	vwait _readable
	return $_readable
}
